/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.jtests.clients.entity;

import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

import junit.framework.Test;
import junit.framework.TestSuite;

import org.objectweb.jonas.jtests.beans.ebasic.SimpleHome;
import org.objectweb.jonas.jtests.beans.ebasic.Simple;

/**
 * This set of test are basic tests on BMP entity home interface.
 * Only specific tests to BMP are here, all tests common to CMP and BMP
 * are in the inherited class A_BasicHomeInterface
 * @author Philippe Coq, Philippe Durieux (jonas team)
 */
public class F_BasicHomeInterfaceEB extends A_BasicHomeInterface {

    private static String BEAN_HOME = "ebasicSimpleEBHome";

    public F_BasicHomeInterfaceEB(String name) {
        super(name);
    }

    public SimpleHome getHome() {
        if (home == null) {
            try {
                home = (SimpleHome) PortableRemoteObject.narrow(ictx.lookup(BEAN_HOME), SimpleHome.class);
            } catch (NamingException e) {
                fail("Cannot get bean home");
            }
        }
        return home;
    }

    public void testIllegalState() throws Exception {
        getHome().findEqualTwo(100, 90);
 
    }

    public void testIllegalState_2() throws Exception {
        Simple e = getHome().create("pk100000", 20, 6);
        try {
            e = getHome().findByName("pk100000");
        } finally {
            // cleaning
            e.remove();
        }
    }

    /**
     * This suite is all BMP test cases
     */
    public static Test suite() {
        return new TestSuite(F_BasicHomeInterfaceEB.class);
    }
  
    public static void main (String args[]) throws Exception{
        String testtorun = null;
        // Get args
        for (int argn = 0; argn < args.length; argn++) {
            String s_arg = args[argn];
            Integer i_arg;
            if (s_arg.equals("-n")) {
                testtorun = args[++argn];
            }
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
	  
            junit.textui.TestRunner.run(new F_BasicHomeInterfaceEB(testtorun));
	   
        }
    }
}
